/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef TEXTUREDEF
#define TEXTUREDEF

#include <gl/image.h>
#include "vect.h"

typedef struct texture {
	int xsize;
	int ysize;
	int bw;
	int alpha;
	int bpp;
	unsigned char **r;
	unsigned char **g;
	unsigned char **b;
	unsigned char **a;
} TEXTURE;

/* PYRAMIDHEIGHT gives the number of levels in the mip map. */
#define PYRAMIDHEIGHT	16	

typedef struct mipmap {
	int levels;
	TEXTURE	 *maps[PYRAMIDHEIGHT];
} MIPMAP;

float frand();
float xsin();
float fnoise3();
float onewrap();
TEXTURE *tmopen();
TEXTURE *tmalloc();
float noisefunc();
float wave();
float ocean();
float turbulence();
float ease();
MIPMAP *mipopen();

#endif TEXTUREDEF
