/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#if FALSE
#include "stdio.h"
#include "gl.h"
#include "device.h"

/* lighting and material stuff */

#define NUM_LIGHT_PARAMS	3
#define XSPECULAR		1
#define LOCAL			2
#define MULTISPEC		3

#define	NUM_COLORS		7
#define	NUM_OBJS		4

#define	NUM_MATERIALS		10
#define MAT_BRASS		1
#define MAT_SHINYBRASS		2
#define MAT_PEWTER		3
#define MAT_SILVER		4
#define MAT_GOLD		5
#define MAT_SHINYGOLD		6
#define MAT_PLASTER		7
#define MAT_REDPLASTIC		8
#define MAT_GREENPLASTIC	9
#define MAT_BLUEPLASTIC		10

/* drawing data types */

#define POLYGON	1
#define LINES	2
#define TRANSPERENT 3
#define DISPLAY	4
#define LMATERIAL 5

#define RGB	8
#define SMOOTH	6
#define NORMAL	9

typedef struct attribs {
	int r, g, b;
	float nx, ny, nz;
} attribs;

typedef struct point {
	struct point 	*next;
	int 		type;
	attribs		*attr;
	float x, y, z;
} point;

typedef struct object {
   	struct object 	*next;
	int 		type;
	attribs		*attr;
	point 		*points;
} object;
#endif

#define FASTMAGIC	0x5423

typedef struct fastobj {
    int npoints;
    int colors;
    int type;
    int material;
    int display;
    int ablend;
    int *data;
    struct fastobj	*swirl;
} fastobj;

fastobj *readfastobj();

#if FALSE
extern int lflag;

/*
 * Wrappers to do either lines or polygons
 */
#define PolyOrLine()	if (lflag == LINES) { \
				bgnclosedline(); \
			} else if (POLYGON) { \
				bgnpolygon(); \
			}

#define EndPolyOrLine() if (lflag == LINES) { \
				endclosedline(); \
			} else if (POLYGON) { \
				endpolygon(); \
			}
#endif
