/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
    glo_obj.h - Definitions for GL based objects.

    Tim Heidmann, Silicon Graphics
    Created    Oct 5, 1988
    Last Edit  July 22, 1991
*/

#ifndef _glo_obj_
#define _glo_obj_

/* End of this object command list */
#define ENDLIST   (-32768)
/* Drawing commands and delimiters */
#define BGNTMSH   (-32767)
#define ENDTMSH   (-32766)
#define SWAPTMSH  (-32765)
#define BGNPOLY   (-32764)
#define ENDPOLY   (-32763)
#define BGNLINE   (-32762)
#define ENDLINE   (-32761)
/* Normal/vertex modes */
#define NPERV     (-32760)
#define NPERP     (-32759)
#define NONORM    (-32758)
/* If i >= USEMATL, use material (i - USEMATL) */
#define USEMATL   (-30000)

typedef struct {
    int *list;          /* List of control values */
    float (*t)[3];      /* Array of triplets: positions or normals */
} glo_ObjTyp, *glo_ObjPtr;

extern glo_ObjTyp glo_cube;

/* glo_object library function Prototypes */
void
glo_DrawObj(glo_ObjPtr);
void
glo_DrawGeometry(glo_ObjPtr);  /* Make the v3f calls, but no n3f or lmbind */
void
glo_DrawNormals(glo_ObjPtr);   /* Draw just the normals as yellow vectors */

glo_ObjPtr
glo_NewObj(int nList, int nTriplets);

glo_ObjPtr
glo_ReadObj(char filename[]);

void
glo_WriteObj(glo_ObjPtr theObj, char filename[]);

void
glo_GetLengths(glo_ObjPtr theObj, int *listLen, int *tripletLen);

#endif
