/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
    shadows.h - Defines for the VGX vshadow program

    Tim Heidmann, Silicon Graphics
    Last Edit   June 28, 1991
*/

#ifndef _shadows_
#define _shadows_

#include <gl.h>
#include "glo_obj.h"

/* Edge list management data structures */
typedef struct {
    Boolean lit; float n[3];
} FaceRec, *FacePtr;
typedef struct {
    Boolean silhouetteFlag, markedFlag;
    struct {
	int face, vertex, nextEdge, nextSide;
    } e[2];
} EdgeRec, *EdgePtr;
typedef struct {
    int nFaces, nEdges;
    FaceRec *faces;
    EdgeRec *edges;
} PolyDataRec, *PolyDataPtr;

extern float obj_posn[][3];
extern float obj_scale[];
extern Matrix obj_rotMatrix[];
extern int obj_litMaterial[];
extern int obj_shadowMaterial[];
extern int obj_highMaterial[];
extern int obj_texture[];
extern glo_ObjPtr obj_drawlist[];
extern PolyDataPtr obj_data[];
extern int nObjects;

extern float light_posn[][3];
extern float jitter_light_posn[][3];
extern float jitter_light_range[][3];
extern int nLights;

extern float eyex[];
extern float gazex[];
extern Matrix scene_rotMatrix;
extern float viewWindow[];

extern float tev_val[], tex_val[];
extern char *sceneFileName;
extern char *imageFileName;

extern Matrix IdentMat;
#endif
